//Cellulat simulation
//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.awt.*;
import java.io.*; 
import java.util.*;
import vrml.external.field.*;
import vrml.external.Node;
import vrml.external.Browser;
import vrml.external.exception.*;
import Proteinat;
import netscape.security.PrivilegeManager;

public class Celulat extends Frame implements Runnable, EventOutObserver
{
  static int maxproteinats = 9;
  static Proteinat[] proteinats = new Proteinat[maxproteinats]; //proteinats vector
  static int selectedproteinat =-1;
  static int refreshrate;
  static Browser browser;
  EventOutSFTime[] touchTime = new EventOutSFTime[maxproteinats];
  Node[] touch = new Node[maxproteinats];
  static Node signals;
  static Node[] signal;
  static EventInMFNode addSigCh;
  static EventInMFNode rmSigCh;
  static String sigstr = new String();
  boolean error = false;
  Random rnd = new Random();
  static TextArea output = null;
  TextField dly,rr;
  Button start;
  
  long delay = 0;
  
  static long t;    //time
  static int SZ = 30; //size of one side of enviroment (which is square)
  Thread sim = null;
  boolean pause = true;
  boolean verbose = false;
  String saveFile = null; 
  public MenuBar menu;
  public Menu simm;
  public MenuItem resetsimm,savesimm,savesimasm,loadsimm;
  
  public Celulat() {
    super ("Celulat Simulation Controls");
    setFont(new Font("TimesRoman",Font.PLAIN,12));
    setBackground(Color.white);
    setLayout(new FlowLayout());
    menu = new MenuBar();
    simm = new Menu("Simulation");
    menu.add(simm);
    savesimm = new MenuItem("Save Simulation");
    simm.add(savesimm);
    savesimasm = new MenuItem("Save Simulation As...");
    simm.add(savesimasm);
    simm.addSeparator();
    loadsimm = new MenuItem("Load Simulation");
    simm.add(loadsimm);
    simm.addSeparator();
    resetsimm = new MenuItem("Reset Simulation");
    simm.add(resetsimm);
    setMenuBar(menu);
    savesimm.disable();
    savesimasm.disable();
    loadsimm.disable();
    
    start = new Button("Start ");
    add(start);
    add(new Button("Clear Output")); 
    add(new Button("Verbose"));
    add( new Label("Delay:"));
    dly = new TextField("0",4);
    add(dly);
    add(new Button("Set Dly"));
    output = new TextArea(5, 55);
    output.setEditable(false);
    output.setFont(new Font("TimesRoman",Font.PLAIN,12));
    add(output);
    add(new Button("Reset Time"));
    refreshrate=5;
    add(new Label("Refresh:"));
    rr = new TextField(String.valueOf(refreshrate),2);
    add(rr);
    add(new Button("Set RR"));
    resize(390,270);
    selectedproteinat =-1;
    show();
    t = 0;
    start();

    sigstr = " Transform{\n" +
    "translation 0 -0.99 0\n" +
    "    children [\n" +
    "        Shape{\n" +
    "          appearance Appearance{\n" +
    "              material Material{\n" +
    "                  diffuseColor 0.05 0.7 0.45\n" +
    "                  transparency 0.6\n" +
      "              }\n" +
      "           }\n" +
      "           geometry Box {size 30 0.01 21}\n" +
    "        }\n" +
    "     ]\n" +
    "}\n";
  }
  
  public void start() {
    int i;
    for (i = 0;i < maxproteinats;i++) {
      proteinats[i] = null;
    }
    output.appendText("\nStarting Celulat....\n");
    browser = (Browser) SimBase.browser;
    try {
      signals = browser.getNode("Signals");
      addSigCh = (EventInMFNode) signals.getEventIn("addChildren");
      rmSigCh = (EventInMFNode) signals.getEventIn("removeChildren");
    }
    catch (InvalidNodeException e) {
      output.appendText("PROBLEMS!: " + e + "\n");
      error = true;
    }
    catch (InvalidEventInException e) {
      output.appendText("PROBLEMS!: " + e + "\n");
      error = true;
    }
    catch (InvalidEventOutException e) {
      output.appendText("PROBLEMS!: " + e + "\n");
      error = true;
    }
    catch (InvalidVrmlException e) {
      output.appendText("PROBLEMS!: " + e + "\n");
      error = true;
    }
    initproteinats();
    output.appendText("Celulat started.\n");
  }

  public void initproteinats() {
    float[] pos=new float[3];
    float[] color=new float[3];
    int i=0;
    pos[0]=(float)-11;pos[1]=(float)-0.5;pos[2]=(float)-14;
    color[0]=(float)0.7;color[1]=(float)0.05;color[2]=(float)0.5;
    proteinats[i] = new Proteinat("External Signal 0",i,1,1,
      (float)-14.5,(float)-12,(float)14.5,(float)-14.5,1,pos,color,t);
    i++;
    pos[0]=(float)-9;pos[1]=(float)0;pos[2]=(float)-11;
    color[0]=(float)0.0;color[1]=(float)0.9;color[2]=(float)0.3;
    proteinats[i] = new Proteinat("Receptor 0",i,2,0,
      (float)-11,(float)-11,(float)-9,(float)-9,2,pos,color,t);
    i++;
    pos[0]=(float)-6;pos[1]=(float)-0.2;pos[2]=(float)-10;
    color[0]=(float)0.1;color[1]=(float)0.4;color[2]=(float)0.9;
    proteinats[i] = new Proteinat("G Protein 0",i,3,0,
      (float)-10,(float)-10,(float)-4,(float)-8.5,(float)1.7,pos,color,t);
    i++;
    pos[0]=(float)-4;pos[1]=(float)0.1;pos[2]=(float)-9.8;
    color[0]=(float)0.23;color[1]=(float)0.45;color[2]=(float)0.35;
    proteinats[i] = new Proteinat("Enzyme 0",i,4,0,
      (float)-9.8,(float)-9.8,(float)-2,(float)-7.5,(float)1.7,pos,color,t);
    i++;
    pos[0]=(float)9;pos[1]=(float)-0.3;pos[2]=(float)-6;
    color[0]=(float)0.43;color[1]=(float)0.65;color[2]=(float)0.05;
    proteinats[i] = new Proteinat("Some Protein 0",i,0,0,
      (float)-9.5,(float)-4,(float)14.2,(float)-14.2,1,pos,color,t);
    i++;
    pos[0]=(float)-3;pos[1]=(float)0;pos[2]=(float)-3;
    color[0]=(float)0.1;color[1]=(float)0.85;color[2]=(float)0.25;
    proteinats[i] = new Proteinat("Some Protein 1",i,0,0,
      (float)-3,(float)-3,(float)-3,(float)-3,1,pos,color,t);
    i++;
    pos[0]=(float)7;pos[1]=(float)0.0;pos[2]=(float)9;
    color[0]=(float)0.5;color[1]=(float)0.5;color[2]=(float)0.5;
    proteinats[i] = new Proteinat("Some Protein 2",i,0,0,
      (float)0,(float)9.5,(float)14,(float)-14,1,pos,color,t);
    i++;
    pos[0]=(float)0;pos[1]=(float)0.2;pos[2]=(float)13;
    color[0]=(float)0.65;color[1]=(float)0.05;color[2]=(float)0.75;
    proteinats[i] = new Proteinat("Some Protein in the nucleus 0",i,0,0,
      (float)12.1,(float)14.4,(float)14.5,(float)-14.5,1,pos,color,t);
    i++;
    pos[0]=(float)0;pos[1]=(float)-0.3;pos[2]=(float)-14;
    color[0]=(float)0.43;color[1]=(float)0.65;color[2]=(float)0.85;
    proteinats[i] = new Proteinat("Some External Protein 0",i,0,0,
      (float)-14.4,(float)-12.1,(float)14,(float)-14,1,pos,color,t);
    i++;
    
    for(i = 0;i < maxproteinats;i++) {
      initproteinat(proteinats[i],i);
      proteinats[i].update(false);
    }
  }
  
  void initproteinat(Proteinat p, int pos) {
    p.prot = browser.getNode("Proteinat"+String.valueOf(pos));
    p.posEv = (EventInSFVec3f)p.prot.getEventIn("set_translation");
    p.rotEv = (EventInSFRotation)p.prot.getEventIn("set_rotation");
    p.prot2 = browser.getNode("Orient"+String.valueOf(pos));
    p.rotEv2 = (EventInSFRotation)p.prot2.getEventIn("set_rotation");
    p.material = browser.getNode("SCOLOR"+String.valueOf(pos));
    p.diffuseColor = (EventInSFColor) p.material.getEventIn("set_color");
    touch[pos] = browser.getNode("TS"+String.valueOf(pos));
    touchTime[pos] = (EventOutSFTime) touch[pos].getEventOut("touchTime");
    touchTime[pos].advise(this, new Integer(pos));
    p.ini(); 
  }

  static void addcalcium() {
    signal = browser.createVrmlFromString(sigstr);
    addSigCh.setValue((Node[])signal);
  }
  static void rmcalcium() {
    rmSigCh.setValue((Node[])signal);
  }  
  
  /*public void savesim() {
    int i,ans = getanimatsnum();
    try {
      PrivilegeManager.enablePrivilege("UniversalFileWrite");
      FileOutputStream ostream = null ;
      try {
        try {
          ostream = new FileOutputStream(saveFile);
        } catch(SecurityException e) {
          output.appendText(e.getMessage());
        }
        ObjectOutputStream p = new ObjectOutputStream(ostream);
        p.writeObject(env);
        p.writeInt(ans);
        for (i = 0;i < maxanimats;i++) {
          if ((animats[i] != null)) {
            savesinglean(animats[i],p);
          }
        }
        p.writeLong(t);
        p.writeLong(delay);
        p.writeInt(refreshrate);
        p.writeBoolean(verbose);
        p.flush();
        ostream.close();
        output.appendText("Simulation saved.\n");
      } catch(IOException ioe) {
        output.appendText(ioe.getMessage());
      }
    } catch (netscape.security.ForbiddenTargetException e) {
      output.appendText("Security Exception: \n" + 
      "Permission to write files forbidden by user. \n" +
      "Simulation couldn't be saved.\n");
      e.printStackTrace(System.err);
    }
  } 
  public void loadsim() {
    int i,ans;
    String tmp ;
    try {
      PrivilegeManager.enablePrivilege("UniversalFileRead");
      FileInputStream istream = null ;
      try {
        try {
          istream = new FileInputStream(saveFile);
        } catch(SecurityException e) {
          output.appendText(e.getMessage());
        }
        ObjectInputStream p = new ObjectInputStream(istream);
        if ( ! pause) {
          sim.stop();
          sim = null;
          output.appendText("Pausing simulation while loading new simulation...\n");
        }
        rmES();//clear environment
        destroyanimats();
        try {
          env = (Environment)p.readObject();
          ans = (int)p.readInt();
          for (i = 0;i < ans;i++) {
            tmp = (String)p.readObject();
            animats[i] = new Animat(tmp,i,t);
            loadsinglean(animats[i],p);
            initanimat(animats[i],i);
            animats[i].update(false);
            output.appendText("Animat "+animats[i].id+" loaded in t= "+String.valueOf(t)+".\n");            
          } 
          t=(long)p.readLong();
          delay=(long)p.readLong();
          refreshrate=(int)p.readInt();
          verbose=(boolean)p.readBoolean();
        } catch (java.lang.ClassNotFoundException e) {
          output.appendText(e.getMessage());
        }
        istream.close();
        dly.setText(String.valueOf(delay));
        rr.setText(String.valueOf(refreshrate));
        restoreEnv();
        output.appendText("Simulation loaded.\n");
        if ( ! pause) {
          sim = new Thread(this, "Simulation");
          sim.start();
          output.appendText("Simulation restored...\n");
        }
      } catch(IOException ioe) {
        output.appendText(ioe.getMessage());
      }
    } catch (netscape.security.ForbiddenTargetException e) {
      output.appendText("Security Exception: \n" + 
      "Permission to read files forbidden by user. \n" +
      "Simulation couldn't be loaded.\n");
      e.printStackTrace(System.err);
    }
  }
   */
  
  public boolean action(Event evt, Object whichAction) {
    boolean ok = true; 
    if (evt.target instanceof MenuItem) {
      if ((String)whichAction == "Save Simulation") {
        if(saveFile == null) { 
          FileDialog fd = new FileDialog(this,"Save Simulation",FileDialog.SAVE);
          fd.setVisible(true);
          saveFile = new String(fd.getDirectory()+fd.getFile());
          if(saveFile != null) { 
            output.appendText("Saving simulation in file "+saveFile+"...\n");
            //savesim();
          } else {
            output.appendText("Saving cancelled\n");
          }
        } else {
          output.appendText("Saving simulation in file "+saveFile+"...\n");
          //savesim();
        }
        } else
        if ((String)whichAction == "Save Simulation As...") {
        FileDialog fd = new FileDialog(this,"Save Simulation",FileDialog.SAVE);
        fd.setVisible(true);
        saveFile = new String(fd.getDirectory()+fd.getFile());
        if(saveFile != null) { 
          output.appendText("Saving simulation in file "+saveFile+"...\n");
          //savesim();
        } else {
          output.appendText("Saving cancelled\n");
        }
        } else
        if ((String)whichAction == "Load Simulation") {
        FileDialog fd = new FileDialog(this,"Load Simulation",FileDialog.LOAD);
        fd.setVisible(true);
        saveFile = new String(fd.getDirectory()+fd.getFile());
        if(saveFile != null) { 
          output.appendText("Loading simulation from file "+saveFile+"...\n");
          //loadsim();
        } else {
          output.appendText("Loading cancelled\n");
        }
        } else
        if ((String)whichAction == "Reset Simulation") {
        SimBase.reset();
      } 
      } else
      if (evt.target instanceof Button) {
      Button b = (Button) evt.target;
      if (b.getLabel() == "Pause") {
        if (pause) {
          sim = new Thread(this, "Simulation"); 
          sim.start();
          output.appendText("Simulation Restored.\n");
        }
        else {
          output.appendText("Simulation Paused.\n");
          sim.stop();
          sim = null;
        }
        pause =! pause;
      }
      else if (b.getLabel() == "Start ") {
        start.setLabel("Pause");
        sim = new Thread(this, "Simulation");
        sim.start();
        pause = false;
        output.appendText("Simulation Started.\n");
      }
      else if (b.getLabel() == "Verbose") {
        if(verbose)
          output.appendText("OK, I'll be quiet.\n");
        else
          output.appendText("To inform and serve, sir!\n");
        verbose =! verbose;
      }
      else if (b.getLabel() == "Reset Time") {
        output.appendText("Time resetted\n");
        t = 0;
      }
      else if (b.getLabel() == "Set RR") {
        int rrprov =-1;
        try {
          rrprov = Integer.valueOf(rr.getText()).intValue();
        }
        catch (NumberFormatException e) {
          output.appendText("Please fill the fileds correctly!\n");
          ok = false;
        }
        if (ok) {
          if (rrprov <= 0) {
            output.appendText("Refresh rate must be positive!\n");
          } else {
            refreshrate=rrprov;
            output.appendText("New refresh rate: "+String.valueOf(refreshrate)+" sim cycles per visual refresh\n");
          }
        }
      }
      else if (b.getLabel() == "Set Dly") {
        long dlyprov =-1;
        try {
          dlyprov = Long.valueOf(dly.getText()).longValue();
        }
        catch (NumberFormatException e) {
          output.appendText("Please fill the fileds correctly!\n");
          ok = false;
        }
        if (ok) {
          if (dlyprov < 0) {
            output.appendText("Delay can't be negative!\n");
          } else {
            delay = dlyprov;
            output.appendText("New delay rate: "+String.valueOf(delay)+" milliseconds per sim cycle\n");
          }
        }
      }
      else if (b.getLabel() == "Clear Output") {
        output.setText("\nNice and clean...\n");
      }
    }
    return true;
  }
  
  public void callback(EventOut who, double when, Object which) {
    Integer whichNum = (Integer) which;
    if (whichNum.intValue() == 0) {
      selectedproteinat = 0;
      output.appendText("Proteinat "+proteinats[0].id+" selected\n");
      proteinats[0].show();
      proteinats[0].output.appendText("Proteinat selected.\n");
      } else
      if (whichNum.intValue() == 1) {
      selectedproteinat = 1;
      output.appendText("Proteinat "+proteinats[1].id+" selected\n");
      proteinats[1].show();
      proteinats[1].output.appendText("Proteinat selected.\n");
      } else
      if (whichNum.intValue() == 2) {
      selectedproteinat = 2;
      output.appendText("Proteinat "+proteinats[2].id+" selected\n");
      proteinats[2].show();
      proteinats[2].output.appendText("Proteinat selected.\n");
      } else
      if (whichNum.intValue() == 3) {
      selectedproteinat = 3;
      output.appendText("Proteinat "+proteinats[3].id+" selected\n");
      proteinats[3].show();
      proteinats[3].output.appendText("Proteinat selected.\n");
      } else
      if (whichNum.intValue() == 4) {
      selectedproteinat = 4;
      output.appendText("Proteinat "+proteinats[4].id+" selected\n");
      proteinats[4].show();
      proteinats[4].output.appendText("Proteinat selected.\n");
      } else
      if (whichNum.intValue() == 5) {
      selectedproteinat = 5;
      output.appendText("Proteinat "+proteinats[5].id+" selected\n");
      proteinats[5].show();
      proteinats[5].output.appendText("Proteinat selected.\n");
      } else
      if (whichNum.intValue() == 6) {
      selectedproteinat = 6;
      output.appendText("Proteinat "+proteinats[6].id+" selected\n");
      proteinats[6].show();
      proteinats[6].output.appendText("Proteinat selected.\n");
      } else
      if (whichNum.intValue() == 7) {
      selectedproteinat = 7;
      output.appendText("Proteinat "+proteinats[7].id+" selected\n");
      proteinats[7].show();
      proteinats[7].output.appendText("Proteinat selected.\n");
      } else
      if (whichNum.intValue() == 8) {
      selectedproteinat = 8;
      output.appendText("Proteinat "+proteinats[8].id+" selected\n");
      proteinats[8].show();
      proteinats[8].output.appendText("Proteinat selected.\n");
      } else
      if (whichNum.intValue() == 9) {
      selectedproteinat = 9;
      output.appendText("Proteinat "+proteinats[9].id+" selected\n");
      proteinats[9].show();
      proteinats[9].output.appendText("Proteinat selected.\n");
      } else
      output.appendText("I couldn't get that event...\n");
  }
    
  public void run() {
    int i;
    Thread myThread = Thread.currentThread();
    while (sim == myThread) { //Simulation
      try {
        sim.sleep(delay);
      } catch (InterruptedException insomnia) { }
      t++;
      if (verbose) {
        output.appendText("t: "+String.valueOf(t)+"\n");
      }
      for (i = 0;i < maxproteinats;i++) {
        if (proteinats[i] != null) {
          proteinats[i].go();
        }
      }
    }
  }
  
  public static boolean refresh(){
    if ((t % refreshrate) == 0)
      return true;
    else
      return false;
  }
  
  public void stop() {
    if ( ! pause) {
      sim.stop();
      sim = null;//stop sim thread
    }
  }
  
  public void destroy() {
    int i;
    stop();
    output.appendText("Closing Simulation... (this might take a little while...)");
    for (i = 0;i < maxproteinats;i++) {
      if (proteinats[i] != null) {
        //proteinats[i].destroy();
        proteinats[i] = null;
      }
    }
    this.hide();
    dispose();
  }
  
}